/*
 * PluginManager.h 
 *
 * Copyright (c) 2008 Wind River Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License version 2.1 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Lesser GNU General Public License for more details.
 *
 * You should have received a copy of the Lesser GNU General Public License version 2.1
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
/**
 * \ingroup audiobusman
 * \file
 *    Audio manager plugin interface
 *
 *  
 *
 * \version $Revision: 1.7 $
 * \date    $Date: 2008/07/12 00:59:37 $
 */
#ifndef __PLUGIN_MANAGER_H__
#define __PLUGIN_MANAGER_H__

/**************************************************************************/
/*                              Includes                                  */
/**************************************************************************/
#include <glib.h>
#include <gmodule.h>
#include "PluginData.h"

/**************************************************************************/
/*                               Defines                                  */
/**************************************************************************/

/**************************************************************************/
/*                              Typedefs                                  */
/**************************************************************************/

/**************************************************************************/
/*                          Functions Declarations                        */
/**************************************************************************/

/**************************************************************************/
/*                                                                        */
/*  Function Name: PM_LoadPlugin                                        */
/*                                                                        */
/**************************************************************************/
/**
 *  Function to load plugin shared libraires and intialize the plugin
 *
 *  \return 
 *   TRUE on success
 *   FALSE on failure
 *
 **************************************************************************
*/

gboolean PM_LoadPlugin
(
    PluginData_t *pPlugin, const char *pPluginInitFnName
);

/**************************************************************************/
/*                                                                        */
/*  Function Name: PM_UnloadPlugin                                         */
/*                                                                        */
/**************************************************************************/
/**
 *  Function to unload plugin shared libraires and free plugin resources.
 *
 *  \return 
 *   TRUE on success
 *   FALSE on failure
 *
 **************************************************************************
*/
void PM_UnloadPlugin
(
    PluginData_t *pPlugin
);
#endif //__PLUGIN_MANAGER_H__
