/*
 * AudioBusManagerUtils.h 
 *
 * Copyright (c) 2008 Wind River Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License version 2.1 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Lesser GNU General Public License for more details.
 *
 * You should have received a copy of the Lesser GNU General Public License version 2.1
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
/**
 * \ingroup audiobusman
 * \file
 *   This header provides Audio Manager utility functions.
 *
 * \version $Revision: 1.5 $
 * \date    $Date: 2008/07/12 00:59:38 $
 */

#ifndef __AUDIO_BUS_MANAGER_UTILS_H__
#define __AUDIO_BUS_MANAGER_UTILS_H__

#include "paclient.h"
#include "AudioBusManagerPlugin.h"

ABM_Results_t ABMU_PulseAudioModuleSetup
(
    int MaxAlsaDevices, /**< Maximum Alsa devicec to be setup with pulse audio*/
    gchar *pPluginType, /**<  Type of plugin trying to load PA modules*/
    ABMU_PA_ModuleLoadHandler pModueLoadHandle /**< Function pointer for passing
                                       module load data back to the calling
                                       plugin*/
);

ABM_Results_t ABMU_PulseAudioModuleTerminate
(
    int ModuleIndex /**< Index of the pulseaudio module to be terminated*/
);
#endif              /* __AUDIO_BUS_MANAGER_UTILS_H__ */
