/*
 * custom_marshall.c 
 *
 * Copyright (c) 2008 Wind River Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License version 2.1 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Lesser GNU General Public License for more details.
 *
 * You should have received a copy of the Lesser GNU General Public License version 2.1
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
/// @cond internal_documentation
/**
 * \file 
 *    This file contains the implementation of marshaling functions needed for
 *    custom return types from dbus signals. 
 *
 * \version $Revision: 1.3 $
 * \date    $Date: 2008/07/12 01:27:17 $
 */
/**************************************************************************/
/*                              Includes                                  */
/**************************************************************************/
#include <glib-object.h>

/**************************************************************************/
/*                               Defines                                  */
/**************************************************************************/
#define g_marshal_value_peek_boolean(v)  g_value_get_boolean (v)
#define g_marshal_value_peek_char(v)     g_value_get_char (v)
#define g_marshal_value_peek_uchar(v)    g_value_get_uchar (v)
#define g_marshal_value_peek_int(v)      g_value_get_int (v)
#define g_marshal_value_peek_uint(v)     g_value_get_uint (v)
#define g_marshal_value_peek_long(v)     g_value_get_long (v)
#define g_marshal_value_peek_ulong(v)    g_value_get_ulong (v)
#define g_marshal_value_peek_int64(v)    g_value_get_int64 (v)
#define g_marshal_value_peek_uint64(v)   g_value_get_uint64 (v)
#define g_marshal_value_peek_enum(v)     g_value_get_enum (v)
#define g_marshal_value_peek_flags(v)    g_value_get_flags (v)
#define g_marshal_value_peek_float(v)    g_value_get_float (v)
#define g_marshal_value_peek_double(v)   g_value_get_double (v)
#define g_marshal_value_peek_string(v)   (char*) g_value_get_string (v)
#define g_marshal_value_peek_param(v)    g_value_get_param (v)
#define g_marshal_value_peek_boxed(v)    g_value_get_boxed (v)
#define g_marshal_value_peek_pointer(v)  g_value_get_pointer (v)
#define g_marshal_value_peek_object(v)   g_value_get_object (v)

/**************************************************************************/
/*                          Public Functions                              */
/**************************************************************************/
/* VOID:STRING,STRING,INT */

void g_cclosure_user_marshal_VOID__STRING_STRING_INT
(
    GClosure *closure, GValue *return_value, guint n_param_values, const GValue *param_values, gpointer invocation_hint,
    gpointer marshal_data
)
{
    typedef void (*GMarshalFunc_VOID__STRING_STRING_INT) (gpointer data1,
    gpointer arg_1,
    gpointer arg_2,
    gint arg_3,
    gpointer data2);

    register GMarshalFunc_VOID__STRING_STRING_INT callback;
    register GCClosure *cc = (GCClosure *)closure;
    register gpointer data1, data2;

    g_return_if_fail (n_param_values == 4);

    if (G_CCLOSURE_SWAP_DATA (closure))
    {
        data1 = closure->data;
        data2 = g_value_peek_pointer (param_values + 0);
    }
    else
    {
        data1 = g_value_peek_pointer (param_values + 0);
        data2 = closure->data;
    }

    callback = (GMarshalFunc_VOID__STRING_STRING_INT) (marshal_data ? marshal_data : cc->callback);

    callback (data1,                                          g_marshal_value_peek_string (param_values + 1),
              g_marshal_value_peek_string (param_values + 2), g_marshal_value_peek_int (param_values + 3),
              data2);
}
/* VOID:STRING,UINT */
void g_cclosure_user_marshal_VOID__STRING_UINT
(
    GClosure *closure, GValue *return_value, guint n_param_values, const GValue *param_values, gpointer invocation_hint,
    gpointer marshal_data
)
{
    typedef void (*GMarshalFunc_VOID__STRING_UINT) (gpointer data1,
    gpointer arg_1,
    guint arg_2,
    gpointer data2);

    register GMarshalFunc_VOID__STRING_UINT callback;
    register GCClosure *cc = (GCClosure *)closure;
    register gpointer data1, data2;

    g_return_if_fail (n_param_values == 3);

    if (G_CCLOSURE_SWAP_DATA (closure))
    {
        data1 = closure->data;
        data2 = g_value_peek_pointer (param_values + 0);
    }
    else
    {
        data1 = g_value_peek_pointer (param_values + 0);
        data2 = closure->data;
    }

    callback = (GMarshalFunc_VOID__STRING_UINT) (marshal_data ? marshal_data : cc->callback);

    callback (data1, g_marshal_value_peek_string (param_values + 1), g_marshal_value_peek_uint (param_values + 2),
              data2);
}
/* VOID:STRING,STRING  */
    void g_cclosure_user_marshal_VOID__STRING_STRING
(
    GClosure *closure, GValue *return_value, guint n_param_values, const GValue *param_values, gpointer invocation_hint,
    gpointer marshal_data
)
{
    typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1,
    gpointer arg_1,
    gpointer arg_2,
    gpointer data2);

    register GMarshalFunc_VOID__STRING_STRING callback;
    register GCClosure *cc = (GCClosure *)closure;
    register gpointer data1, data2;

    g_return_if_fail (n_param_values == 3);

    if (G_CCLOSURE_SWAP_DATA (closure))
    {
        data1 = closure->data;
        data2 = g_value_peek_pointer (param_values + 0);
    }
    else
    {
        data1 = g_value_peek_pointer (param_values + 0);
        data2 = closure->data;
    }

    callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);

    callback (data1, g_marshal_value_peek_string (param_values + 1), g_marshal_value_peek_string (param_values + 2),
              data2);
}
/// @endcond 
