/*
 * custom_marshall.h 
 *
 * Copyright (c) 2008 Wind River Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License version 2.1 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Lesser GNU General Public License for more details.
 *
 * You should have received a copy of the Lesser GNU General Public License version 2.1
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
/// @cond internal_documentation
/**
 * \file 
 *    This file contains the declarations of marshaling functions needed for
 *    custom return types from dbus signals. 
 *
 * \version $Revision: 1.1 $
 * \date    $Date: 2008/06/11 21:22:25 $
 */
#ifndef __g_cclosure_user_marshal_MARSHAL_H__
#define __g_cclosure_user_marshal_MARSHAL_H__

/**************************************************************************/
/*                              Includes                                  */
/**************************************************************************/
#include	<glib-object.h>

/**************************************************************************/
/*                          Functions Declarations                        */
/**************************************************************************/
G_BEGIN_DECLS

/* VOID:STRING,UINT,INT */
extern void g_cclosure_user_marshal_VOID__STRING_STRING_INT(
    GClosure *closure,
    GValue *return_value,
    guint n_param_values,
    const GValue *param_values,
    gpointer invocation_hint,
    gpointer marshal_data);

/* VOID:STRING,STRING  */
extern void g_cclosure_user_marshal_VOID__STRING_STRING(
    GClosure *closure,
    GValue *return_value,
    guint n_param_values,
    const GValue *param_values,
    gpointer invocation_hint,
    gpointer marshal_data);

/* VOID:STRING,UINT */
extern void g_cclosure_user_marshal_VOID__STRING_UINT(
    GClosure *closure,
    GValue *return_value,
    guint n_param_values,
    const GValue *param_values,
    gpointer invocation_hint,
    gpointer marshal_data);

G_END_DECLS

#endif /* __g_cclosure_user_marshal_MARSHAL_H__ */
/// @endcond 
